diff --git a/storage/innobase/trx/trx0i_s.cc b/storage/innobase/trx/trx0i_s.cc
index e0dbe8e..c17fb67 100644
--- a/storage/innobase/trx/trx0i_s.cc
+++ b/storage/innobase/trx/trx0i_s.cc
@@ -860,6 +860,29 @@ static void trx_i_s_cache_clear(
 
 /** Fetches the data needed to fill the 3 INFORMATION SCHEMA tables into the
  table cache buffer. Cache must be locked for write. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+static void fetch_data_into_cache_low(
+    trx_i_s_cache_t *cache, /*!< in/out: cache */
+    const trx_t *trx)       /*!< in/out: transaction */
+{
+  i_s_locks_row_t *requested_lock_row;
+
+  assert_trx_nonlocking_or_in_list(trx);
+  if (add_trx_relevant_locks_to_cache(cache, trx, &requested_lock_row) != 0u) {
+    auto trx_row = static_cast<i_s_trx_row_t *>(
+        table_cache_create_empty_row(&cache->innodb_trx, cache));
+    if (trx_row != nullptr) {
+      if (fill_trx_row(trx_row, trx, requested_lock_row, cache) == TRUE) {
+        return;
+      }
+      --cache->innodb_trx.rows_used;
+    }
+  }
+
+  /* memory could not be allocated */
+  cache->is_truncated = TRUE;
+}
+#else
 static void fetch_data_into_cache_low(
     trx_i_s_cache_t *cache,  /*!< in/out: cache */
     bool read_write,         /*!< in: only read-write
@@ -923,22 +946,39 @@ static void fetch_data_into_cache_low(
     trx_mutex_exit(trx);
   }
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Fetches the data needed to fill the 3 INFORMATION SCHEMA tables into the
  table cache buffer. Cache must be locked for write. */
 static void fetch_data_into_cache(trx_i_s_cache_t *cache) /*!< in/out: cache */
 {
   ut_ad(lock_mutex_own());
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(trx_sys_mutex_own());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   trx_i_s_cache_clear(cache);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  mutex_enter(&trx_sys->mutex);
+  for (const trx_t *trx = UT_LIST_GET_FIRST(trx_sys->trx_list); trx != nullptr;
+       trx = UT_LIST_GET_NEXT(trx_list, trx)) {
+    if (trx_is_started(trx) && trx != purge_sys->query->trx) {
+      fetch_data_into_cache_low(cache, trx);
+      if (cache->is_truncated == TRUE) {
+        break;
+      }
+    }
+  }
+  mutex_exit(&trx_sys->mutex);
+#else
   /* Capture the state of the read-write transactions. This includes
   internal transactions too. They are not on mysql_trx_list */
   fetch_data_into_cache_low(cache, true, &trx_sys->rw_trx_list);
 
   /* Capture the state of the read-only active transactions */
   fetch_data_into_cache_low(cache, false, &trx_sys->mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   cache->is_truncated = FALSE;
 }
@@ -957,11 +997,15 @@ int trx_i_s_possibly_fetch_data_into_cache(
 
   lock_mutex_enter();
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   trx_sys_mutex_enter();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   fetch_data_into_cache(cache);
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   lock_mutex_exit();
 
diff --git a/storage/innobase/trx/trx0purge.cc b/storage/innobase/trx/trx0purge.cc
index f6d2193..583ccb0 100644
--- a/storage/innobase/trx/trx0purge.cc
+++ b/storage/innobase/trx/trx0purge.cc
@@ -240,7 +240,11 @@ void trx_purge_sys_create(ulint n_purge_threads, purge_pq_t *purge_queue) {
 
   new (&purge_sys->view) ReadView();
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_sys->clone_oldest_view();
+#else
   trx_sys->mvcc->clone_oldest_view(&purge_sys->view);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   purge_sys->view_active = true;
 
@@ -348,7 +352,11 @@ void trx_purge_add_update_undo_to_history(
                  undo_header + TRX_UNDO_HISTORY_NODE, mtr);
 
   if (update_rseg_history_len) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_sys->rseg_history_len.fetch_add(n_added_logs);
+#else
     os_atomic_increment_ulint(&trx_sys->rseg_history_len, n_added_logs);
+#endif /* HAVE_LOCK_FREE_READVIEW */
     srv_wake_purge_thread_if_not_active();
   }
 
@@ -384,7 +392,11 @@ static void trx_purge_remove_log_hdr(trx_rsegf_t *rseg_hdr,
   flst_remove(rseg_hdr + TRX_RSEG_HISTORY, log_hdr + TRX_UNDO_HISTORY_NODE,
               mtr);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_sys->rseg_history_len.fetch_sub(1);
+#else
   os_atomic_decrement_ulint(&trx_sys->rseg_history_len, 1);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 
 /** Frees a rollback segment which is in the history list.
@@ -1655,7 +1667,9 @@ static void trx_purge_rseg_get_next_history_log(
     mtr_commit(&mtr);
 
 #ifdef UNIV_DEBUG
+#ifndef HAVE_LOCK_FREE_READVIEW
     trx_sys_mutex_enter();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     /* Add debug code to track history list corruption reported
     on the MySQL mailing list on Nov 9, 2004. The fut0lst.cc
@@ -1680,7 +1694,9 @@ static void trx_purge_rseg_get_next_history_log(
                                   " threads to expedite purging of undo logs.";
     }
 
+#ifndef HAVE_LOCK_FREE_READVIEW
     trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 #endif
     return;
   }
@@ -2214,7 +2230,11 @@ ulint trx_purge(ulint n_purge_threads, /*!< in: number of purge tasks
 
   purge_sys->view_active = false;
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_sys->clone_oldest_view();
+#else
   trx_sys->mvcc->clone_oldest_view(&purge_sys->view);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   purge_sys->view_active = true;
 
diff --git a/storage/innobase/trx/trx0roll.cc b/storage/innobase/trx/trx0roll.cc
index 861d3f3..fe805b2 100644
--- a/storage/innobase/trx/trx0roll.cc
+++ b/storage/innobase/trx/trx0roll.cc
@@ -186,11 +186,19 @@ static dberr_t trx_rollback_low(trx_t *trx) {
     case TRX_STATE_FORCED_ROLLBACK:
     case TRX_STATE_NOT_STARTED:
       trx->will_lock = 0;
+#ifdef HAVE_LOCK_FREE_READVIEW
+      ut_ad(trx->mysql_thd != nullptr);
+#else
       ut_ad(trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
       return (DB_SUCCESS);
 
     case TRX_STATE_ACTIVE:
+#ifdef HAVE_LOCK_FREE_READVIEW
+      ut_ad(trx->mysql_thd != nullptr);
+#else
       ut_ad(trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
       assert_trx_nonlocking_or_in_list(trx);
       /* Check an validate that undo is available for GTID. */
       trx_undo_gtid_add_update_undo(trx, false, true);
@@ -285,7 +293,11 @@ dberr_t trx_rollback_last_sql_stat_for_mysql(
   here, because the statement rollback should be invoked for a
   running active MySQL transaction that is associated with the
   current thread. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(trx->mysql_thd != nullptr);
+#else
   ut_ad(trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   switch (trx->state) {
     case TRX_STATE_FORCED_ROLLBACK:
@@ -390,7 +402,11 @@ executed after the savepoint */
   dberr_t err;
 
   ut_ad(trx_state_eq(trx, TRX_STATE_ACTIVE));
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(trx->mysql_thd != nullptr);
+#else
   ut_ad(trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* Free all savepoints strictly later than savep. */
 
@@ -437,7 +453,11 @@ dberr_t trx_rollback_to_savepoint_for_mysql(
   here, because the savepoint rollback should be invoked for a
   running active MySQL transaction that is associated with the
   current thread. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(trx->mysql_thd != nullptr);
+#else
   ut_ad(trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   savep = trx_savepoint_find(trx, savepoint_name);
 
@@ -524,7 +544,11 @@ dberr_t trx_release_savepoint_for_mysql(
   trx_named_savept_t *savep;
 
   ut_ad(trx_state_eq(trx, TRX_STATE_ACTIVE));
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(trx->mysql_thd != nullptr);
+#else
   ut_ad(trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   savep = trx_savepoint_find(trx, savepoint_name);
 
@@ -581,7 +605,9 @@ static void trx_rollback_active(trx_t *trx) /*!< in/out: transaction */
 
   ut_a(thr == que_fork_start_command(fork));
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   trx_sys_mutex_enter();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   trx_roll_crash_recv_trx = trx;
 
@@ -591,7 +617,9 @@ static void trx_rollback_active(trx_t *trx) /*!< in/out: transaction */
 
   rows_to_undo = trx_roll_max_undo_no;
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   if (rows_to_undo > 1000000000) {
     rows_to_undo = rows_to_undo / 1000000;
@@ -623,6 +651,71 @@ static void trx_rollback_active(trx_t *trx) /*!< in/out: transaction */
   trx_roll_crash_recv_trx = NULL;
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+static bool trx_rollback_recovered_callback(rw_trx_hash_element_t *element,
+                                            std::vector<trx_t *> *trx_list) {
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    mutex_enter(&trx->mutex);
+    if (trx->is_recovered && trx_state_eq(trx, TRX_STATE_ACTIVE)) {
+      ut_ad(trx != trx_dummy_sess->trx);
+      trx_list->push_back(trx);
+    }
+    mutex_exit(&trx->mutex);
+  }
+  mutex_exit(&element->mutex);
+  return false;
+}
+
+/** Rollback any incomplete transactions which were encountered in crash
+ recovery.
+
+ If the transaction already was committed, then we cleanup a possible insert
+ undo log. If the transaction was not yet committed, then we roll it back.
+
+ Note: For XA recovered transactions, we rely on MySQL to do rollback. They
+ will be in TRX_STATE_PREPARED state. If the server is shutdown and they are
+ still lingering in trx_sys_t::trx_list then the shutdown will hang.
+
+ @param [in] all true=roll back all recovered active transactions;
+                 fasle=roll back any incomplete dictionary transaction */
+void trx_rollback_recovered(bool all) {
+  std::vector<trx_t *> trx_list;
+
+  ut_a(srv_force_recovery < SRV_FORCE_NO_TRX_UNDO);
+
+  /* Collect list of recovered ACTIVE transaction ids first. Once collected, no
+  other thread is allowed to modify or remove these transactions from
+  rw_trx_hash.*/
+  trx_sys->rw_trx_hash.iterate_no_dups(
+      reinterpret_cast<lf_hash_walk_func *>(trx_rollback_recovered_callback),
+      &trx_list);
+
+  while (!trx_list.empty()) {
+    trx_t *trx = trx_list.back();
+    trx_list.pop_back();
+
+#ifdef UNIV_DEBUG
+    ut_ad(trx != nullptr);
+    trx_mutex_enter(trx);
+    ut_ad(trx->is_recovered && trx_state_eq(trx, TRX_STATE_ACTIVE));
+    trx_mutex_exit(trx);
+#endif /* UNIV_DEBUG */
+
+    if (all || trx_get_dict_operation(trx) != TRX_DICT_OP_NONE) {
+      trx_rollback_active(trx);
+      if (trx->error_state != DB_SUCCESS) {
+        trx->error_state = DB_SUCCESS;
+        trx_sys->deregister_rw(trx);
+        trx_free_at_shutdown(trx);
+      } else {
+        trx_free(trx);
+      }
+    }
+  }
+}
+#else
 /** Rollback or clean up any resurrected incomplete transactions. It assumes
  that the caller holds the trx_sys_t::mutex and it will release the
  lock if it does a clean up or rollback.
@@ -730,6 +823,7 @@ void trx_rollback_or_clean_recovered(
                                 " completed";
   }
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Rollback or clean up any incomplete transactions which were
 encountered in crash recovery.  If the transaction already was
@@ -746,7 +840,17 @@ void trx_recovery_rollback_thread() {
 
   ut_ad(!srv_read_only_mode);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (trx_sys->rw_trx_hash.size() > 0) {
+    ib::info(ER_IB_MSG_1189) << "Starting in background the rollback"
+                                " of uncommitted transactions";
+    trx_rollback_recovered(true);
+    ib::info(ER_IB_MSG_1190) << "Rollback of non-prepared transactions"
+                                " completed";
+  }
+#else
   trx_rollback_or_clean_recovered(TRUE);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   destroy_thd(thd);
 }
